﻿using System;
using NetOffice;
using NetOffice.Attributes;
namespace NetOffice.WordApi.Enums
{
	 /// <summary>
	 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
	 /// </summary>
	 ///<remarks> MSDN Online Documentation: http://msdn.microsoft.com/en-us/en-us/library/office/ff837291.aspx </remarks>
	[SupportByVersion("Word", 9,10,11,12,14,15,16)]
	[EntityType(EntityType.IsEnum)]
	public enum WdTextureIndex
	{
		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>0</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureNone = 0,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>25</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture2Pt5Percent = 25,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>50</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture5Percent = 50,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>75</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture7Pt5Percent = 75,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>100</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture10Percent = 100,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>125</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture12Pt5Percent = 125,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>150</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture15Percent = 150,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>175</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture17Pt5Percent = 175,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>200</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture20Percent = 200,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>225</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture22Pt5Percent = 225,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>250</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture25Percent = 250,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>275</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture27Pt5Percent = 275,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>300</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture30Percent = 300,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>325</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture32Pt5Percent = 325,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>350</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture35Percent = 350,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>375</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture37Pt5Percent = 375,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>400</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture40Percent = 400,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>425</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture42Pt5Percent = 425,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>450</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture45Percent = 450,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>475</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture47Pt5Percent = 475,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>500</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture50Percent = 500,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>525</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture52Pt5Percent = 525,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>550</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture55Percent = 550,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>575</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture57Pt5Percent = 575,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>600</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture60Percent = 600,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>625</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture62Pt5Percent = 625,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>650</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture65Percent = 650,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>675</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture67Pt5Percent = 675,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>700</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture70Percent = 700,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>725</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture72Pt5Percent = 725,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>750</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture75Percent = 750,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>775</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture77Pt5Percent = 775,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>800</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture80Percent = 800,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>825</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture82Pt5Percent = 825,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>850</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture85Percent = 850,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>875</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture87Pt5Percent = 875,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>900</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture90Percent = 900,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>925</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture92Pt5Percent = 925,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>950</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture95Percent = 950,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>975</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTexture97Pt5Percent = 975,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>1000</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureSolid = 1000,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-1</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDarkHorizontal = -1,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-2</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDarkVertical = -2,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-3</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDarkDiagonalDown = -3,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-4</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDarkDiagonalUp = -4,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-5</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDarkCross = -5,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-6</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDarkDiagonalCross = -6,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-7</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureHorizontal = -7,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-8</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureVertical = -8,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-9</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDiagonalDown = -9,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-10</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDiagonalUp = -10,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-11</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureCross = -11,

		 /// <summary>
		 /// SupportByVersion Word 9, 10, 11, 12, 14, 15, 16
		 /// </summary>
		 /// <remarks>-12</remarks>
		 [SupportByVersion("Word", 9,10,11,12,14,15,16)]
		 wdTextureDiagonalCross = -12
	}
}